#!/usr/bin/env ruby

$: << '.'
$: << File.join(File.dirname(__FILE__), "../lib")
$: << File.join(File.dirname(__FILE__), "../ext")

require 'rails'
require 'oj'

$data = {:ticker=>"ASAI3", :price=>18.7, :rate=>-0.8.to_d}

def encode
  p "JSON.generate: #{JSON.generate($data)}"
  p "Oj.generate: #{Oj.generate($data)}"
  p "Oj.dump: #{Oj.dump($data)}"
  p "to_json: #{$data.to_json}"
  p "ActiveSupport::JSON.encode: #{ActiveSupport::JSON.encode($data)}"
end

puts "With Oj version (#{Oj::VERSION})"

puts
puts "Before optimizing"
encode

Oj.optimize_rails
Oj.default_options = {
  mode: :rails,
  bigdecimal_as_decimal: true,
  bigdecimal_load: true
}

puts
puts "After optimizing"
encode
